#include "plumpconfig.h"


int plump_memoryRead(plump_t *p, plumpaddr_t addr, void *buffer, unsigned long bufferLength, unsigned long *bytesRead)
{
	int ret = PLUMP_ERROR_NOTSUPPORTED;

	if (p->vftable.memoryRead)
		ret = p->vftable.memoryRead(p, addr, buffer, bufferLength, bytesRead);

	return ret;
}

int plump_memoryWrite(plump_t *p, plumpaddr_t addr, void *buffer, unsigned long bufferLength, unsigned long *bytesWritten)
{
	int ret = PLUMP_ERROR_NOTSUPPORTED;

	if (p->vftable.memoryWrite)
		ret = p->vftable.memoryWrite(p, addr, buffer, bufferLength, bytesWritten);

	return ret;
}

int plump_memoryIsValid(plump_t *p, plumpaddr_t addr)
{
	int ret = PLUMP_ERROR_NOTSUPPORTED;

	if (p->vftable.memoryIsValid)
		ret = p->vftable.memoryIsValid(p, addr);

	return ret;
}

int plump_memoryGetEndOfSegment(plump_t *p, plumpaddr_t addr, plumpaddr_t *end)
{
	int ret = PLUMP_ERROR_NOTSUPPORTED;

	if (p->vftable.memoryGetEndOfSegment)
		ret = p->vftable.memoryGetEndOfSegment(p, addr, end);

	return ret;
}
